generic
	type TElemento is private;
package Pilas is
	type Pila is limited private;
	-- Cuando se crea una variable de tipo Pila, est vaca

	procedure Apilar(P: in out Pila; E: in TElemento);
	-- Aade un elemento en la cima de P

	procedure Desapilar(P: in out Pila);
	-- Quita el elemento que ocupa la cima de P
	-- Si P est vaca lanza E_Pila_Vaca

	function Examinar(P: in Pila) return TElemento;
	-- Devuelve el elemento que ocupa la cima de P
	-- Si P est vaca lanza E_Pila_Vaca

	function Es_Vaca(P: in Pila) return Boolean;
	-- Evala si P est vaca

	function Tamao(P: in Pila) return Natural;
	-- Devuelve el nmero de elementos almacenados en P

	-- Se lanza cuando, en una pila vaca, se intenta realizar
	-- una operacin no aplicable a las pilas vacas
	E_Pila_Vaca: exception;

private
	type Lista is Array(1..100) of TElemento;
	type Pila is record
		Elementos: Lista;
		Tamao   : Natural := 0;
	end record;
end Pilas;
