package multirramas;

import java.util.LinkedList;
import java.util.Stack;
import comn.*;
import contenedores.AlmacenableComparable;
import contenedores.ExcepcinContenedor;

/**
 * Implementacin de un contenedor usando un rbol B
 */
public class rbolB extends Multirrama {
   int mnimoClaves;

   /**
    * Clase auxiliar que permite devolver una pareja formada por
    * una clave y el enlace asociado 
    */
   private class ParejaInsertar {
      public byte[] clave;
      public int direccin;
   }

   ParejaInsertar particin_1_2(Nodo nodo) {
      ParejaInsertar pa = new ParejaInsertar();
      Nodo nuevoNodo = new Nodo();
      int ncnuevo = Orden / 2;
      int ncnodo = Orden - ncnuevo - 1;
      int dirNuevo = fichero.tomarPgina();
      nuevoNodo.direccin(dirNuevo);
      nuevoNodo.cardinal(ncnuevo);
      nuevoNodo.enlace(0, nodo.enlace(ncnodo + 1));
      // [xxxx] [   ] => [xx  ] [xx  ]
      for (int i = 1; i <= nuevoNodo.cardinal(); i++) { 
         nuevoNodo.clave(i, nodo.clave(ncnodo + 1 + i));
         nuevoNodo.enlace(i, nodo.enlace(ncnodo + 1 + i));
      }
      pa.clave = nodo.clave(ncnodo + 1);
      pa.direccin = nuevoNodo.direccin();
      nodo.cardinal(ncnodo);
      escribir(nodo);
      escribir(nuevoNodo);
      return pa;
   }

   void particin_2_3(Nodo padre, int posizq, Nodo izq, Nodo der) {
      int clavesRepartir = izq.cardinal() + der.cardinal() - 1;
      Nodo reg = new Nodo();
      int ncizq = (clavesRepartir) / 3;
      int ncreg = (clavesRepartir + 1) / 3;
      int ncder = (clavesRepartir + 2) / 3;
      int antncder = der.cardinal();
      int antncizq = izq.cardinal();
      //Se inserta en el padre una nueva clave y la nueva direccin
      reg.direccin(fichero.tomarPgina());
      padre.insertar(izq.clave(ncizq + 1), reg.direccin(), posizq + 1);
      //Pasamos datos de izq a reg: [xxx] [   ] => [xx ] [x  ]
      reg.cardinal(ncreg);
      reg.enlace(0, izq.enlace(ncizq + 1));
      for (int i = ncizq + 2; i <= antncizq; i++) {
         reg.clave(i - ncizq - 1, izq.clave(i));
         reg.enlace(i - ncizq - 1, izq.enlace(i));
      }
      izq.cardinal(ncizq);
      //Pasamos el dato del padre a la posicin correspondiente de reg
      reg.clave(antncizq - ncizq, padre.clave(posizq + 2));
      int posl = antncizq - ncizq;
      reg.enlace(posl, der.enlace(0)); // [x  ] [yyy] => [xy ] [ yy]
      for (int i = posl + 1; i <= ncreg; i++) {
         reg.clave(i, der.clave(i - posl));
         reg.enlace(i, der.enlace(i - posl));
      }
      int ncpas = antncder - ncder;
      //Pasamos al padre el valor correspondiente y compactamos der
      padre.clave(posizq + 2, der.clave(ncpas));
      der.enlace(0, der.enlace(ncpas)); // [ yy] => [yy ]
      for (int i = ncpas + 1; i <= antncder; i++) {
         der.clave(i - ncpas, der.clave(i));
         der.enlace(i - ncpas, der.enlace(i));
      }
      der.cardinal(ncder);
      escribir(izq); // [xx ] [xy ] [yy ]
      escribir(reg);
      escribir(der);
   }

   void rotacinizqder(Nodo padre, int posizq, Nodo izq, Nodo der) {
      int clavesRepartir = izq.cardinal() + der.cardinal();
      int ncizq = (clavesRepartir) / 2;
      int ncder = clavesRepartir - ncizq;
      int ncpas = ncder - der.cardinal();
      int antncder = der.cardinal();
      //Hacemos hueco en nodo der: [yy  ] => [ yy ]
      der.cardinal(ncder);
      for (int i = antncder; i >= 1; i--) {
         der.clave(i + ncpas, der.clave(i));
         der.enlace(i + ncpas, der.enlace(i));
      }
      der.enlace(ncpas, der.enlace(0));
      //Rellenar el nodo der: [xxxx] [ yy ] => [xxx ] [xyy ]
      der.clave(ncpas, padre.clave(posizq + 1));
      for (int i = ncizq + 2; i <= izq.cardinal(); i++) {
         der.clave(i - (ncizq + 1), izq.clave(i));
         der.enlace(i - (ncizq + 1), izq.enlace(i));
      }
      der.enlace(0, izq.enlace(ncizq + 1));
      // Modificar el nodo padre
      padre.clave(posizq + 1, izq.clave(ncizq + 1));
      //Modificar el nodo izq
      izq.cardinal(ncizq);
      //Se escribe en el fichero los tres nodos
      escribir(padre);
      escribir(izq);
      escribir(der);
   }

   void rotacinderizq(Nodo padre, int posizq, Nodo izq, Nodo der) {
      int clavesRepartir = izq.cardinal() + der.cardinal();
      int ncder = (clavesRepartir) / 2;
      int ncizq = clavesRepartir - ncder;
      int ncpas = der.cardinal() - ncder;
      int antncizq = izq.cardinal();
      //Pasamos la clave del padre y datos de der a izq
      izq.cardinal(ncizq);
      izq.clave(antncizq + 1, padre.clave(posizq + 1));
      izq.enlace(antncizq + 1, der.enlace(0));
      for (int i = 1; i < ncpas; i++) { // [xx  ] [yyyy] => [xxy ] [ yyy]
         izq.clave(antncizq + 1 + i, der.clave(i));
         izq.enlace(antncizq + 1 + i, der.enlace(i));
      }
      //Pasamos clave al padre
      padre.clave(posizq + 1, der.clave(ncpas));
      //Quitamos hueco en der
      der.enlace(0, der.enlace(ncpas));
      for (int i = 1; i <= ncder; i++) { // [ yyy] => [yyy ]
         der.clave(i, der.clave(i + ncpas));
         der.enlace(i, der.enlace(i + ncpas));
      }
      der.cardinal(ncder);
      escribir(padre);
      escribir(izq);
      escribir(der);
   }

   void recombinacin_2_1(Nodo padre, int posizq, Nodo izq, Nodo der) {
      //Bajamos la clave discriminante en el padre al final del izquierdo
      int antncizq = izq.cardinal();
      izq.cardinal(izq.cardinal() + 1 + der.cardinal());
      izq.clave(antncizq + 1, padre.clave(posizq + 1));
      //Pasamos el enlace cero de der a izq ya que no encaja en el bucle
      izq.enlace(antncizq + 1, der.enlace(0));
      //Pasamos el resto de claves y enlaces
      // [xx  ] [xx  ] => [xxxx] [    ]
      for (int i = 1; i <= der.cardinal(); i++) {
         izq.clave(antncizq + 1 + i, der.clave(i));
         izq.enlace(antncizq + 1 + i, der.enlace(i));
      }
      //Quitamos del padre la clave y el enlace a der
      padre.extraer(posizq + 1);
      escribir(izq);
      fichero.liberarPgina(der.direccin());
   }

   void recombinacin_3_2(Nodo padre, int posReg, Nodo izq, Nodo reg, Nodo der) {
      int aRepartir = izq.cardinal() + reg.cardinal() + der.cardinal() + 1;
      int ncder = aRepartir / 2;
      int ncizq = aRepartir - ncder;
      int antncizq = izq.cardinal();
      int antncder = der.cardinal();
      //Rellenamos el hermano izquierdo
      izq.cardinal(ncizq);
      izq.clave(antncizq + 1, padre.clave(posReg));
      izq.enlace(antncizq + 1, reg.enlace(0));
      // [xx  ] [yy  ] => [xxy ] [ y  ]
      for (int i = antncizq + 2; i <= ncizq; i++) {
         izq.clave(i, reg.clave(i - antncizq - 1));
         izq.enlace(i, reg.enlace(i - antncizq - 1));
      }
      //Desplazamiento del hermano derecho para hacer hueco
      der.cardinal(ncder);
      int ncpas = ncder - antncder;
      for (int i = antncder; i >= 1; i--) { // [zz  ] => [ zz ]
         der.clave(i + ncpas, der.clave(i));
         der.enlace(i + ncpas, der.enlace(i));
      }
      der.enlace(ncpas, der.enlace(0));
      der.clave(ncpas, padre.clave(posReg + 1));
      //Rellenamos el hermano derecho
      // [ y  ] [ zz ] => [    ] [yzz ]
      for (int i = ncpas - 1; i >= 1; i--) {
         der.clave(i, reg.clave(reg.cardinal() + i - ncpas + 1));
         der.enlace(i, reg.enlace(reg.cardinal() + i - ncpas + 1));
      }
      der.enlace(0, reg.enlace(reg.cardinal() - ncpas + 1));
      //modificar el nodo padre
      fichero.liberarPgina(reg.direccin());
      escribir(izq);
      escribir(der);
      padre.extraer(posReg);
      padre.clave(posReg, reg.clave(reg.cardinal() - ncpas + 1));
   }

   public void crear(String ruta, int tamaoDatos, int Orden) {
      cerrar();
      this.tamaoDatos = tamaoDatos;
      this.Orden = Orden;
      if (Orden < 5) throw new ExcepcinContenedor(
            "Orden inferior a 5 en rbol B");
      Nodo nodo = new Nodo();
      nombreFichero = ruta;
      fichero.crear(nombreFichero, nodo.tamao(), 4);
      raiz = Fichero.dirNula;
      numElem = 0;
      mnimoClaves = (Orden + 1) / 2 - 1;
      fichero.adjunto(0, raiz);
      fichero.adjunto(1, numElem);
      fichero.adjunto(2, tamaoDatos);
      fichero.adjunto(3, Orden);
   };

   public void crear(String ruta, int tamaoDatos) {
      crear(ruta, tamaoDatos, 100);
   };

   public void abrir(String ruta) {
      fichero.abrir(ruta);
      raiz = fichero.adjunto(0);
      numElem = fichero.adjunto(1);
      tamaoDatos = fichero.adjunto(2);
      Orden = fichero.adjunto(3);
      mnimoClaves = (Orden + 1) / 2 - 1;
   };

   public void cerrar() {
      fichero.cerrar();
   };

   public void vaciar() {
      fichero.cerrar();
      crear(nombreFichero, tamaoDatos);
   };

   public void insertar(Object o) {
      AlmacenableComparable alma = (AlmacenableComparable) o;
      byte[] dato = alma.aByte();
      conv = alma;  //permite conversiones byte[] => AlmacenableComparable
      Stack pila = new Stack();
      if (buscar(alma, pila)) return; //No se admiten repetidos
      Nodo nodoActual = new Nodo();
      InfoPila info;
      ParejaInsertar pa = new ParejaInsertar();
      pa.clave = dato;
      pa.direccin = Fichero.dirNula;
      fichero.adjunto(1, ++numElem);
      if (!pila.empty()) { //El rbol no est vaco
         info = (InfoPila) pila.pop();
         nodoActual = info.nodo;
         int pos = info.pos;
         nodoActual.insertar(pa.clave, pa.direccin, pos + 1);
         if (nodoActual.cardinal() < Orden) { //No hay problema
            escribir(nodoActual);
            return;
         }
         while (!pila.empty()) { //Arreglar sobrecarga
            info = (InfoPila) pila.pop();
            Nodo der = new Nodo(), izq = new Nodo();
            Nodo padre = info.nodo;
            pos = info.pos;
            if (pos > 0) { //Tiene hermano izquierdo
               izq = leer(padre.enlace(pos - 1));
               if (izq.cardinal() < Orden - 1) { //Resuelto
                  rotacinderizq(padre, pos - 1, izq, nodoActual);
                  return;
               }
            }
            if (pos < padre.cardinal()) { //Tiene hermano derecho
               der = leer(padre.enlace(pos + 1));
               if (der.cardinal() < Orden - 1) { //Resuelto
                  rotacinizqder(padre, pos, nodoActual, der);
                  return;
               }
            }
            //No se puede rotar => se parte
            if (pos == 0) particin_2_3(padre, pos, nodoActual, der);
            else particin_2_3(padre, pos - 1, izq, nodoActual);
            if (padre.cardinal() < Orden) { //Resuelto
               escribir(padre);
               return;
            }
            nodoActual = padre;
         }
         //Se parte la raz
         pa = particin_1_2(nodoActual);
      }
      //Se crea una nueva raz
      nodoActual.cardinal(1);
      nodoActual.enlace(0, raiz);
      nodoActual.clave(1, pa.clave);
      nodoActual.enlace(1, pa.direccin);
      nodoActual.direccin(fichero.tomarPgina());
      raiz = nodoActual.direccin();
      escribir(nodoActual);
      fichero.adjunto(0, raiz);
   }

   public void extraer(Object o) {
      AlmacenableComparable alma = (AlmacenableComparable) o;
       conv = alma;
      Stack pila = new Stack();
      if (!buscar(alma, pila)) //Si no est, salimos sin hacer nada
      return;
      fichero.adjunto(1, --numElem);
      Nodo nodoActual = new Nodo();
      InfoPila info = (InfoPila) pila.pop();
      nodoActual = info.nodo;
      int pos = info.pos;
      if (nodoActual.enlace(0) != Fichero.dirNula) {
         //Extraccin desde un nodo no hoja
         pila.add(new InfoPila(info.nodo, info.pos));
         //Hay que buscar el sucesor y cambiarlo
         LinkedList cola = new LinkedList();
         int dir = nodoActual.enlace(pos);
         do { //Descendemos por las ramas izquierdas
            nodoActual = leer(dir);
            dir = nodoActual.enlace(0);
            if (dir == Fichero.dirNula) pos = 1;
            else pos = 0;
            //Guardamos el camino en una cola
            cola.addLast(new InfoPila(nodoActual, pos));
         } while (dir != Fichero.dirNula);
         info = (InfoPila) pila.pop();
         //Se sustituye por el sucesor
         info.nodo.clave(info.pos, nodoActual.clave(1));
         //Se escribe por si no hay ms modificaciones
         escribir(info.nodo);
         pila.add(info);
         while (!cola.isEmpty()) {
            //Se pasa el camino de la cola a la pila
            nodoActual = ((InfoPila) cola.getFirst()).nodo;
            pila.add(cola.getFirst());
            cola.removeFirst();
         }
         info = (InfoPila) pila.pop();
         nodoActual = info.nodo;
         pos = info.pos;
      }
      //Extraccin en un nodo hoja
      nodoActual.extraer(pos);
      while (nodoActual.cardinal() < mnimoClaves
            && nodoActual.direccin() != raiz) {
         Nodo padre, der = new Nodo(), izq = new Nodo();
         info = (InfoPila) pila.pop();
         padre = info.nodo; //Se toma el padre de la pila
         pos = info.pos;
         if (pos < padre.cardinal()) { //Tiene hermano derecho
            der = leer(padre.enlace(pos + 1));
            if (der.cardinal() > mnimoClaves) {
               rotacinderizq(padre, pos, nodoActual, der);
               return;
            }
         }
         if (pos > 0) { //Tiene hermano izquierdo
            izq = leer(padre.enlace(pos - 1));
            if (izq.cardinal() > mnimoClaves) {
               rotacinizqder(padre, pos - 1, izq, nodoActual);
               return;
            }
         }
         //No se puede rotar => se recombina
         if (pos > 0 && pos < padre.cardinal()) 
              recombinacin_3_2(padre, pos, izq, nodoActual, der);
         else if (pos > 0)
              recombinacin_2_1(padre, pos - 1, izq, nodoActual);
         else recombinacin_2_1(padre, pos, nodoActual, der);
         nodoActual = padre;
      }
      if (nodoActual.cardinal() > 0) {
         //Se escribe el nodo, si tiene informacin
         escribir(nodoActual);
      } else //La raz se ha quedado sin datos
      {
         raiz = nodoActual.enlace(0);
         fichero.liberarPgina(nodoActual.direccin());
         fichero.adjunto(0, raiz);
      }
   }

   public boolean est(Object e) {
      AlmacenableComparable alma = (AlmacenableComparable) e;
      conv = alma;
      return buscar(alma, new Stack());
   }

   public boolean esVaco() {
      return tamao() == 0;
   }

   public int tamao() {
      return numElem;
   }
}